function HealHelp_OnLoad()
 SLASH_HEALHELP1 = "/hh";
 SLASH_HEALHELP2 = "/healhelp";
 SlashCmdList["HEALHELP"] = HealHelp_SlashCmd;
 if (DEFAULT_CHAT_FRAME) then 
                    		   DEFAULT_CHAT_FRAME:AddMessage("Skrom's Heal Help v.1.7.3 Loaded", 1.0, 0.84, 0.0, 1.0);
                			     end
BINDING_NAME_HH_AUTOHEAL = "Auto Heal";
BINDING_HEADER_HH_AUTOHEAL_HEADER = "Skrom's Autoheal Macro";
c4 = 1
overHealPct = .5
HealHelp_ORIG_BonusScanner_Update = BonusScanner_Update;
BonusScanner_Update = HealHelp_GatherData;
end

function HealHelp_SlashCmd(msg) -- Slash Command Handler
		if msg == "opt" then  --opt opens the options
		    HealHelp_Opt(); 
		elseif msg == "" then --no argument causes the healing macro to take effect.
		    HealHelp_AutoHeal();
		elseif msg == "refresh" then --refresh reloads the user data
			HealHelp_GatherData();
		else -- anything not listed above causes a mini help line to be displayed
		    DEFAULT_CHAT_FRAME:AddMessage("Usage: type /healhelp opt for a list of options or just /healhelp to initiate the healing feature (Can also be bound to a hotkey using the keybindings interface)");
		end
end

function HealHelp_Opt() -- Load the options frame after /healhelp opt is called
	HHConfigFrame:Show()
end

function HealHelp_SaveOptions() -- Saves the overheal slider and any other options I might add
	overHealPct = getglobal("HHConfigFrameSliderOverheal"):GetValue();
	overHealPct = overHealPct * 100
	overHealPct = math.floor(overHealPct + .5)
	overHealPct = overHealPct / 100
	HHConfigFrame:Hide()
	HealHelp_GatherData()
end

function HealHelp_Colors() --Color settings through the options menu
		function HealHelp_SaveColors()
         HealHelp_UserVars.Chat["HealHelpMSG"].r, HealHelp_UserVars.Chat["HealHelpMSG"].g, HealHelp_UserVars.Chat["HealHelpMSG"].b = ColorPickerFrame:GetColorRGB();
		 c4 = OpacitySliderFrame:GetValue();
		end
		function HealHelp_RevertColors(prevvals)
		 HealHelp_UserVars.Chat["HealHelpMSG"].r, HealHelp_UserVars.Chat["HealHelpMSG"].g, HealHelp_UserVars.Chat["HealHelpMSG"].b = unpack(prevvals)
		end
		ColorPickerFrame.previousValues = {HealHelp_UserVars.Chat["HealHelpMSG"].r, HealHelp_UserVars.Chat["HealHelpMSG"].g, HealHelp_UserVars.Chat["HealHelpMSG"].b}
		ColorPickerFrame:Show();
		ColorPickerFrame:SetColorRGB(HealHelp_UserVars.Chat["HealHelpMSG"].r, HealHelp_UserVars.Chat["HealHelpMSG"].g, HealHelp_UserVars.Chat["HealHelpMSG"].b);
		ColorPickerFrame.func = HealHelp_SaveColors
		ColorPickerFrame.cancelFunc = HealHelp_RevertColors
		

end

function HealHelp_TargetSelect()
		 local t="player"; --Player is the default, gotta look after yourself!
   		 health=UnitHealth("player") / UnitHealthMax("player");
		 
		 if (GetNumRaidMembers() > 0) then
		 	i = GetNumRaidMembers();
		 	finalTargetList={};
		 	table.insert(finalTargetList, {t,health});
		 	InRangeList={};
		 	for n=1,i,1 do                     
			 	if ( CheckInteractDistance("raid"..n, 4) ) then  --Build a list of everyone in the raid who is withing ~24 yards
				 	InRangeList[n]="raid"..n;
			    end
			end
		    if ( InRangeList ) then
				for key,unit in pairs(InRangeList) do  
				  if ( not UnitIsDeadOrGhost(unit)) then
					query=UnitHealth(unit) / UnitHealthMax(unit);
					table.insert(finalTargetList,{unit,query})
				  end
				end	
			local function listSort(a,b) return a[2] < b[2] end
    table.sort(finalTargetList, listSort);
    t= finalTargetList[1][1];
			end
			
		elseif (GetNumPartyMembers() > 0) then	
		 InRangeList={};
		 i = GetNumPartyMembers();
		 
		 for n=1,i,1 do
		 	 if ( CheckInteractDistance("party"..n, 4) ) then -- Same thing as above only for group, not raid
				InRangeList[n]="party"..n;
		     end
		 end
		 if ( InRangeList ) then
				for key,unit in pairs(InRangeList) do  
				  if ( not UnitIsDeadOrGhost(unit)) then
					query=UnitHealth(unit) / UnitHealthMax(unit);
					table.insert(finalTargetList,{unit,query})
				  end
				end	
			local function listSort(a,b) return a[2] < b[2] end
    table.sort(finalTargetList, listSort);
    t= finalTargetList[1][1];
			end
		 end
		 InRangeList = nil
		 return t;
end

function HealHelp_AutoHeal()
     AutoTarget=HealHelp_TargetSelect();
     AutoTargetName=UnitName(AutoTarget);
     
     if (UnitCanCooperate("player","target")) then  --if you are targeting a friendly
		   if (not UnitIsUnit("target",AutoTarget)) then  --but the friendly is not who you are trying to heal
		  	   TargetUnit(AutoTarget); --target the poor chap who needs the lubbin
		   end
		 end
		 
	if (UnitClass("Player") == "Paladin") then
		if(IsBuffActive("Blessing of Light",AutoTarget)) then
			b,bidx=IsBuffActive("Blessing of Light",AutoTarget)
			HHTooltip:SetOwner(HHTooltip, "ANCHOR_NONE")
			HHTooltip:SetPlayerBuff(bidx)
   			HH_BOL_TOOLTIP=getglobal("HHTooltipTextLeft2"):GetText()
   			
		end
	end
	H=UnitHealthMax(AutoTarget)-UnitHealth(AutoTarget);  --Get the actual amount that needs healing
	local r=table.getn(sr)  --Table of heals and their values, from HealHelp_GatherData();
	
	   for i=r,1,-1 do if(H>sr[i]) then  --Step through each available spell to see if it is < amount needed any spell that heals too much is discarded
   CastSpellByName(myspells[i][1])
   if (SpellIsTargeting()) then SpellTargetUnit(AutoTarget)  --Spell Targeting with a feedback message
   HealHelp_Msg("HealHelpMSG","Healing: "..AutoTargetName.." for "..myspells[i][2].." to "..myspells[i][3].." (Assume: "..math.floor(sr[i] + .5)..").");
								break; --Break the for
								end
	   					end
	   end
		 
end
